Attribute VB_Name = "DX_Invaders_MAIN"
Public Declare Function GetKeyState Lib "user32" (ByVal nVirtKey As Long) As Integer
Public Declare Function ShowCursor Lib "user32" (ByVal bShow As Long) As Long
Public Declare Function sndPlaySound Lib "winmm.dll" Alias "sndPlaySoundA" (ByVal lpszSoundName As String, ByVal uFlags As Long) As Long
Public Declare Sub Sleep Lib "kernel32" (ByVal dwMilliseconds As Long)

Public Invader(0 To 7, 0 To 4) As Boolean
Public InvaderFrame As Boolean
Public OldInvaderFrame As Boolean
Public PauseFrame As Byte
Public AllInvadersDead As Boolean
Public SleepTime As Integer
Public Frames As Integer
Public ShipHasExploded As Boolean

Public Type tPack
  x As Integer
  xm As Integer
  y As Integer
End Type

Public Pack As tPack

Public Type tBullet
  x As Integer
  y As Integer
  ym As Integer
  Color As Long
End Type

Public Const MAXBULLETS = 100
Public Bullet(0 To MAXBULLETS) As tBullet
Public CurBullet As Byte

Public Type tShip
  x As Single
  xm As Single
  Shield As Byte
End Type

Public Ship As tShip
Public Const SHIPSPEED = 15

Public Level As Byte

Public x As Integer
Public y As Integer
Public i As Integer
Public i2 As Integer
Public i3 As Integer

'reason for game over
Const INVADED = 1
Const SHOT = 2
Const GAMECOMPLETED = 3

Sub Main()
Randomize Timer
MsgBox "Welcome to DX Invaders by Simon Price. You should know the story, just move left and right to dodge incoming bullets and press the up arrow key to give 'em some back. Good luck!", vbInformation, "DX Invaders by Simon Price"
'start up DX
Form1.CrankItUp
'change screen res
ModDX7.SetDisplayMode 640, 480, 16
'load graphix
ModSurfaces.LoadAllPics

'set the game speed (this is constantly adjusted to keep the game running at 30 fps)
SleepTime = 30

'do intro screen
DoIntro

'set up level 1
SetUpLevel

'enter main game loop
MainGameLoop

'if you get to here, game is complete!
GameOver GAMECOMPLETED
End Sub

Sub DoIntro()
sndPlaySound App.Path & "\SoundFX\Intro.wav", &H1

ModDX7.SetRect SrcRect, 0, 0, 640, 480
BackBuffer.BltFast 0, 0, Background, SrcRect, DDBLTFAST_WAIT
View.Flip Nothing, DDFLIP_WAIT

Do
DoEvents
If Key Then Exit Sub
Loop Until Form1.Key

sndPlaySound App.Path & "\SoundFX\Start.wav", 0
ModDX7.ClearSurface Background, 640, 480
End Sub

Sub SetUpLevel()
Level = Level + 1

'position the ship
With Ship
  .Shield = 10
  .x = 320
  .xm = 0
End With

'position the pack of invaders
With Pack
  .x = 0
  .y = 0
  .xm = 1
End With

'make all invaders alive
For x = 0 To 7
For y = 0 To 4
  Invader(x, y) = True
Next
Next

'reset all bullets
For i = 1 To MAXBULLETS
  Bullet(i).x = -1
  Bullet(i).y = 0
  Bullet(i).ym = 0
Next

End Sub

Sub DoCoolMessage(Message As String)
Dim Position As Byte
Dim i As Integer
Dim G As Byte
Dim GStep As Byte

G = 0
GStep = 255 \ Len(Message)

ModDX7.ClearSurface BackBuffer, 640, 320

For Position = 1 To Len(Message)
G = G + GStep
BackBuffer.SetForeColor RGB(0, G, 0)
BackBuffer.DrawText 0, 0, Left(Message, Position), True
For i = 1 To 1000
DoEvents
Next
View.Flip Nothing, DDFLIP_WAIT
Next

End Sub

Sub MainGameLoop()

On Error Resume Next

StartOfLevel:

Do
DoEvents

Frames = Frames + 1

Sleep SleepTime

'clear the backbuffer
ModDX7.SetRect DestRect, 0, 0, 640, 480
ModDX7.SetRect SrcRect, 0, 0, 1, 1
BackBuffer.Blt DestRect, Sprites, SrcRect, DDBLT_WAIT
 
If PauseFrame = 20 Then
  InvaderFrame = Not InvaderFrame
  PauseFrame = 0
Else
  PauseFrame = PauseFrame + 1
End If

'''''''''''''''''''''''''''''''''''''''''''''
'DO BULLET STUFF

For i = 1 To MAXBULLETS

'if bullet is in play...
If Bullet(i).x <> -1 Then
  'move bullet
  y = Bullet(i).y
  Bullet(i).y = Bullet(i).y + Bullet(i).ym
  'draw bullet
  BackBuffer.SetForeColor Bullet(i).Color
  BackBuffer.DrawLine Bullet(i).x, Bullet(i).y, Bullet(i).x, y
  Select Case Bullet(i).y
    Case 0 To 480
    Case Else
    'if bullet goes off-screen, take it out of play
    Bullet(i).x = -1
  End Select
  
  If Bullet(i).Color = vbWhite Then
    
  'if bullet has been shot by the ship, check for hits to invaders
  Select Case Bullet(i).x
  Case Pack.x To Pack.x + 470
        Select Case (Bullet(i).x - Pack.x) Mod 60
        Case 0 To 50
            x = (Bullet(i).x - Pack.x) \ 60
            i2 = -1
            For y = 0 To 4
              If Invader(x, y) Then i2 = y
            Next
            y = i2
            If i2 <> -1 Then
                Select Case Bullet(i).y
                Case Pack.y + 50 * y To Pack.y + 50 * y + 50
                    'invader has been hit so take invader and bullet out of game
                    sndPlaySound App.Path & "\SoundFX\Squish.wav", &H1
                      Invader(x, y) = False
                      Bullet(i).x = -1
                End Select
            End If
        End Select
  End Select
         
  Else
  
  'if bullet is from invader, check if has hit the ship
    Select Case Bullet(i).y
      Case 400 To 450
        Select Case Bullet(i).x
          Case Ship.x - ((Bullet(i).y - 400) / 2) To Ship.x + ((Bullet(i).y - 400) / 2)
             'bullet has hit spaceship so decrease shield and play hit sound
            sndPlaySound App.Path & "\SoundFX\Hit.wav", &H1
             Ship.Shield = Ship.Shield - 1
             'and get rid of that bullet
             Bullet(i).x = -1
             'if shield = 0, then it's game over
             If Ship.Shield = 0 Then ShipHasExploded = True
        End Select
    End Select
       
  End If

End If

Next

'''''''''''''''''''''''''''''''''''''''''''''
'DO INVADER STUFF

MoveSomeMore:

'move the pack of invaders
If Pack.xm > 0 Then
'if moving right, x is the rightmost invader
    i = -1
    For x = 7 To 0 Step -1
      For y = 0 To 4
        If Invader(x, y) Then i = x
      Next
    If i = x Then Exit For
    Next

    If i = -1 Then Exit Do

    x = Pack.x + Pack.xm + x * 60 + 50

Else
'if moving left, x is the leftmost invader
    x = Pack.x

End If

Select Case x

  Case 0 To 640
    'move the invaders sideways
    Pack.x = Pack.x + Pack.xm

  Case Else
    'invaders have reached the edge of screen, change direction
    Pack.xm = -Pack.xm
    Pack.y = Pack.y + 30

    i2 = -1
    For y = 0 To 4
      For x = 0 To 7
        If Invader(x, y) Then i2 = y
      Next
    Next
    
    'if invaders are at the bottom, it's game over
    If i2 <> -1 Then
      If Pack.y + (i2 * 60) + 50 > 400 Then
        sndPlaySound App.Path & "\SoundFX\Lose.wav", 0
         GameOver INVADED
      End If
    End If

End Select

If Int(Rnd * (11 - Level)) = 0 Then GoTo MoveSomeMore

'make some of the invaders shoot, mostly the ones above you!
For x = 0 To 7
    i2 = -1
    For y = 0 To 4
        If Invader(x, y) Then i2 = y
    Next
    If i2 <> -1 Then
    y = i2
      If Int(Rnd * (((Abs(Pack.x + x * 60 + 30)) - Ship.x)) * (1.5 - Level / 10)) = 1 Then

            'position bullet according to index of invader
            Bullet(CurBullet).x = Pack.x + 60 * x + 25
            Bullet(CurBullet).y = Pack.y + 60 * y + 50
            Bullet(CurBullet).ym = 3

            'color it according to invader type
            Select Case y
              Case 0
              Bullet(CurBullet).Color = vbRed
              Case 1
              Bullet(CurBullet).Color = vbGreen
              Case 2
              Bullet(CurBullet).Color = vbCyan
              Case 3
              Bullet(CurBullet).Color = vbMagenta
              Case 4
              Bullet(CurBullet).Color = vbYellow
            End Select

            'change to next bullet
            If CurBullet = MAXBULLETS Then
              CurBullet = 0
            Else
              CurBullet = CurBullet + 1
            End If

      End If
    End If
Next

'draw the pack of invaders
AllInvadersDead = True
OldInvaderFrame = InvaderFrame
For x = 0 To 7
For y = 0 To 4
  If Invader(x, y) Then
  AllInvadersDead = False
    If InvaderFrame Then
      ModDX7.SetRect SrcRect, y * 100, 0, 50, 50
    Else
      ModDX7.SetRect SrcRect, y * 100 + 50, 0, 50, 50
    End If
    BackBuffer.BltFast Pack.x + x * 60, Pack.y + y * 60, Sprites, SrcRect, DDBLTFAST_WAIT Or DDBLTFAST_SRCCOLORKEY
    InvaderFrame = Not InvaderFrame
  End If
Next
Next
InvaderFrame = OldInvaderFrame

'''''''''''''''''''''''''''''''''''''''''''''
'DO SPACESHIP STUFF
 
'move the ship
x = Ship.x + Ship.xm
Select Case x
  Case 25 To 615
  'OK to move
  Ship.x = x
  Case Else
  'bounce off side
  Ship.xm = Ship.xm * -0.2
End Select

'slow the ship down
Ship.xm = Ship.xm * 0.99

'draw the spaceship
ModDX7.SetRect SrcRect, 600, 0, 49, 49
BackBuffer.BltFast Ship.x - 25, 400, Sprites, SrcRect, DDBLTFAST_WAIT Or DDBLTFAST_SRCCOLORKEY

'display the shield strength
BackBuffer.SetForeColor vbWhite
'if 30% or lower, make the writing flash
If Ship.Shield <= 3 Then
  If InvaderFrame Then BackBuffer.SetForeColor vbRed
End If
BackBuffer.DrawText 0, 0, "Shield strength = " & Ship.Shield * 10 & "%", True

'flip into view
View.Flip Nothing, DDFLIP_WAIT

If ShipHasExploded Then
'if ship has exploded, play explosion sound and freeze the game
  sndPlaySound App.Path & "\SoundFX\Explode.wav", 0
  'now end the game
  GameOver SHOT
End If

Loop Until AllInvadersDead


'level is complete so do next level
If Level = 10 Then
  GoTo EndOfGame
Else
sndPlaySound App.Path & "\SoundFX\Level.wav", 0
  Level = Level + 1
End If
SetUpLevel
GoTo StartOfLevel

EndOfGame:

End Sub

Sub GameOver(Reason As Byte)
'unload graphix
ModSurfaces.UnloadAllPics
'reset screen res
ModDX7.RestoreDisplayMode
'unload DX
Form1.ShutItDown

Select Case Reason
Case INVADED
MsgBox "You lose! The invaders managed to land of earth!", vbExclamation, "Game Over!"
Case SHOT
MsgBox "You lose! You were killed by the invaders!", vbExclamation, "Game Over!"
Case GAMECOMPLETED
sndPlaySound App.Path & "\SoundFX\Tada.wav", &H1
MsgBox "Excellent!!! You saved the earth from all ten levels of invaders!", vbExclamation, "Game Completed!!!"
End Select

MsgBox "Thanks for playing DX Invaders by Simon Price. To see loads more cool games made in VB, all with the full source code, please visit my website : www.VBgames.co.uk", vbInformation, "See more cool games at www.VBgames.co.uk"

End
End Sub
